std::__fwdlist::_Iterator< _Const, _Ptr > Class Template Reference

`#include <forward_list.h>`

## Public Types

using | difference_type
using | iterator_category
using | pointer
using | reference
using | value_type

## Public Member Functions

constexpr | _Iterator (_Base_ptr __x) noexcept
| _Iterator (const _Iterator &)=default
constexpr | _Iterator (const _Iterator< false, _Ptr > &__i)
constexpr reference | operator* () const noexcept
constexpr _Iterator & | operator++ () noexcept
constexpr _Iterator | operator++ (int) noexcept
constexpr pointer | operator-> () const noexcept
_Iterator & | operator= (const _Iterator &)=default

## Friends

template<typename _Tp, typename _Allocator>
struct | ::_Fwd_list_base
template<typename _Tp, typename _Allocator>
class | ::forward_list
constexpr bool | operator== (const _Iterator &__x, const _Iterator &__y) noexcept

## Detailed Description

template<bool _Const, typename _Ptr>
class std::__fwdlist::_Iterator< _Const, _Ptr >

A forward_list iterator when the allocator uses fancy pointers.

Definition at line 455 of file forward_list.h.

## Member Typedef Documentation

## difference_type

template<bool _Const, typename _Ptr>

using std::__fwdlist::_Iterator< _Const, _Ptr >::difference_type

Definition at line 465 of file forward_list.h.

## iterator_category

template<bool _Const, typename _Ptr>

using std::__fwdlist::_Iterator< _Const, _Ptr >::iterator_category

Definition at line 466 of file forward_list.h.

## pointer

template<bool _Const, typename _Ptr>

using std::__fwdlist::_Iterator< _Const, _Ptr >::pointer

Definition at line 467 of file forward_list.h.

## reference

template<bool _Const, typename _Ptr>

using std::__fwdlist::_Iterator< _Const, _Ptr >::reference

Definition at line 468 of file forward_list.h.

## value_type

template<bool _Const, typename _Ptr>

using std::__fwdlist::_Iterator< _Const, _Ptr >::value_type

Definition at line 464 of file forward_list.h.

## Constructor & Destructor Documentation

## _Iterator() [1/3]

template<bool _Const, typename _Ptr>

std::__fwdlist::_Iterator< _Const, _Ptr >::_Iterator | ( |  | ) |

inline constexpr noexcept

Definition at line 470 of file forward_list.h.

## _Iterator() [2/3]

template<bool _Const, typename _Ptr>

std::__fwdlist::_Iterator< _Const, _Ptr >::_Iterator | ( | const _Iterator< false, _Ptr > & | __i | ) |

inline constexpr

Definition at line 477 of file forward_list.h.

## _Iterator() [3/3]

template<bool _Const, typename _Ptr>

std::__fwdlist::_Iterator< _Const, _Ptr >::_Iterator | ( | _Base_ptr | __x | ) |

inline explicit constexpr noexcept

Definition at line 487 of file forward_list.h.

## Member Function Documentation

## operator*()

template<bool _Const, typename _Ptr>

reference std::__fwdlist::_Iterator< _Const, _Ptr >::operator* | ( |  | ) | const

inline constexpr noexcept

Definition at line 492 of file forward_list.h.

## operator++() [1/2]

template<bool _Const, typename _Ptr>

_Iterator & std::__fwdlist::_Iterator< _Const, _Ptr >::operator++ | ( |  | ) |

inline constexpr noexcept

Definition at line 501 of file forward_list.h.

## operator++() [2/2]

template<bool _Const, typename _Ptr>

_Iterator std::__fwdlist::_Iterator< _Const, _Ptr >::operator++ | ( | int |  | ) |

inline constexpr noexcept

Definition at line 508 of file forward_list.h.

## operator->()

template<bool _Const, typename _Ptr>

pointer std::__fwdlist::_Iterator< _Const, _Ptr >::operator-> | ( |  | ) | const

inline constexpr noexcept

Definition at line 497 of file forward_list.h.

## Friends And Related Symbol Documentation

## ::_Fwd_list_base

template<bool _Const, typename _Ptr>
template<typename _Tp, typename _Allocator>

friend struct ::_Fwd_list_base

friend

Definition at line 537 of file forward_list.h.

## ::forward_list

template<bool _Const, typename _Ptr>
template<typename _Tp, typename _Allocator>

friend class ::forward_list

friend

Definition at line 535 of file forward_list.h.

## operator==

template<bool _Const, typename _Ptr>

bool operator== | ( | const _Iterator< _Const, _Ptr > & | __x,
|  | const _Iterator< _Const, _Ptr > & | __y )

friend

Forward list iterator equality comparison.

Definition at line 520 of file forward_list.h.

The documentation for this class was generated from the following file:

- forward_list.h